#include <iostream>

using namespace std;

int main()
{
    int broj_dana,broj_upita,dan,plazma,upit,brojac_nula = 0;
    cin >> broj_dana >> broj_upita;
    int kupio_plazmu[3000] = {0};
    for(int i = 1; i <= broj_dana; i++){
        cin >> dan >> plazma;
        kupio_plazmu[dan] = plazma;
    }
    int stanje[3000] = {0};
    for(int i = 1; i <= 3000; i++){
        stanje[i] = stanje[i-1] + kupio_plazmu[i];
        if(stanje[i-1] > 0)
            stanje[i]--;
    }
    for(int i = 0; i < broj_upita; i++){
        cin >> upit;
        brojac_nula = 0;
        for(int j = 1; j <= upit; j++){
            if(stanje[j] == 0)
                brojac_nula++;
        }
        cout << upit - brojac_nula << endl;
    }
    return 0;
}